/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jurls;

import jurls.core.approximation.ApproxParameters;
import jurls.examples.approximation.RenderArrayFunction2D;
import jurls.examples.approximation.RenderFunction2D;
import jurls.examples.approximation.RenderParameterizedFunction2D;
import jurls.examples.menu.ApproximatorMenu;
import jurls.examples.menu.ObjectListMenu;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 *
 * @author thorsten
 */
public class ApproximationDemo2D extends javax.swing.JFrame {

    private final ApproxParameters approxParameters = new ApproxParameters(0.01, 0.1);
    private final RenderParameterizedFunction2D renderParameterizedFunction = new RenderParameterizedFunction2D(Color.yellow);
    private int numIterations = 0;
    private int numIterationsPerLoop = 1;
    private final ApproximatorMenu approximatorMenu = new ApproximatorMenu(false);
    private final ObjectListMenu iterationsMenu = new ObjectListMenu(
            "Iterations per frame", 0, 1, 50, 500, 1000, 5000
    );
    private final RenderFunction2D f;
    private final Timer timer = new Timer(5, new ActionListener() {

        @Override
        public void actionPerformed(ActionEvent e) {
            for (int i = 0; i < numIterationsPerLoop; ++i) {
                double x = Math.random();
                double y = Math.random();
                renderParameterizedFunction.oneStepTowards(x, y, f.compute(x, y));
                numIterations++;
            }
            functionRenderer2D1.repaint();
            functionRenderer2D2.repaint();
            /*jTextArea1.setText(
                    "@" + numIterations);*/
            /*+ "\n"
                    + "No. parameters : "
                    + renderParameterizedFunction.getParameterizedFunction().numberOfParameters()*/

        }
    });


    /**
     * Creates new form ApproximationDemo
     */
    public ApproximationDemo2D() {
        initComponents();

        timer.setCoalesce(true);

        approxParameters.setAlpha(Double.parseDouble(alphaComboBox.getSelectedItem().toString()));
        approxParameters.setMomentum(Double.parseDouble(momentumComboBox.getSelectedItem().toString()));

        jMenuBar1.add(approximatorMenu);
        jMenuBar1.add(iterationsMenu);

        approximatorMenu.addActionListener(e -> {
            renderParameterizedFunction.setParameterizedFunction(
                    approximatorMenu.getFunctionGenerator(
                            approxParameters
                    ).generate(2)
            );
            numIterations = 0;
        });
        approximatorMenu.notifyListeners();

        iterationsMenu.addActionListener(e -> numIterationsPerLoop = (int) iterationsMenu.getObject());
        iterationsMenu.notifyListeners();

        int width = 5;
        int height = 5;
        double[][] ys = new double[width][height];
        for (int i = 0; i < ys.length; ++i) {
            for (int j = 0; j < ys[i].length; ++j) {
                ys[i][j] = Math.random() * 10 - 5;
            }
        }
        f = new RenderArrayFunction2D(1, 1, Color.blue, ys);

        functionRenderer2D1.setRenderFunction2D(f);
        functionRenderer2D2.setRenderFunction2D(renderParameterizedFunction);

        timer.start();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    
    private void initComponents() {

        ButtonGroup functionButtonGroup = new ButtonGroup();
        ButtonGroup hiddenButtonGroup = new ButtonGroup();
        ButtonGroup outputButtonGroup = new ButtonGroup();
        JTabbedPane jTabbedPane1 = new JTabbedPane();
        JPanel jPanel1 = new JPanel();
        JPanel jPanel8 = new JPanel();
        functionRenderer2D1 = new jurls.examples.approximation.FunctionRenderer2D();
        JPanel jPanel9 = new JPanel();
        functionRenderer2D2 = new jurls.examples.approximation.FunctionRenderer2D();

        JScrollPane jScrollPane1 = new JScrollPane();
        JTextArea jTextArea1 = new JTextArea();
        JPanel jPanel4 = new JPanel();
        JPanel jPanel5 = new JPanel();
        JPanel jPanel6 = new JPanel();
        alphaComboBox = new javax.swing.JComboBox();
        momentumComboBox = new javax.swing.JComboBox();
        JPanel jPanel7 = new JPanel();
        JLabel jLabel3 = new JLabel();
        JLabel jLabel4 = new JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setLayout(new java.awt.GridLayout(1, 0));

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("desired"));
        jPanel8.setLayout(new java.awt.GridLayout(1, 0));

        javax.swing.GroupLayout functionRenderer2D1Layout = new javax.swing.GroupLayout(functionRenderer2D1);
        functionRenderer2D1.setLayout(functionRenderer2D1Layout);
        functionRenderer2D1Layout.setHorizontalGroup(
            functionRenderer2D1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 285, Short.MAX_VALUE)
        );
        functionRenderer2D1Layout.setVerticalGroup(
            functionRenderer2D1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 327, Short.MAX_VALUE)
        );

        jPanel8.add(functionRenderer2D1);

        jPanel1.add(jPanel8);

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("actual"));
        jPanel9.setLayout(new java.awt.GridLayout(1, 0));

        javax.swing.GroupLayout functionRenderer2D2Layout = new javax.swing.GroupLayout(functionRenderer2D2);
        functionRenderer2D2.setLayout(functionRenderer2D2Layout);
        functionRenderer2D2Layout.setHorizontalGroup(
            functionRenderer2D2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 285, Short.MAX_VALUE)
        );
        functionRenderer2D2Layout.setVerticalGroup(
            functionRenderer2D2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 327, Short.MAX_VALUE)
        );

        jPanel9.add(functionRenderer2D2);

        jPanel1.add(jPanel9);

        jTabbedPane1.addTab("Demo", jPanel1);

        

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        

        

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel5.setLayout(new java.awt.BorderLayout());

        jPanel6.setLayout(new java.awt.GridLayout(0, 1));

        alphaComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0.1", "0.01", "0.001", "0.0001" }));
        alphaComboBox.setSelectedIndex(2);
        alphaComboBox.addActionListener(this::alphaComboBoxActionPerformed);
        jPanel6.add(alphaComboBox);

        momentumComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0.01", "0.1", "0.2", "0.3", "0.4", "0.5", "0.6", "0.7", "0.8", "0.9", "0.95", "0.99" }));
        momentumComboBox.setSelectedIndex(9);
        momentumComboBox.addActionListener(this::momentumComboBoxActionPerformed);
        jPanel6.add(momentumComboBox);

        jPanel5.add(jPanel6, java.awt.BorderLayout.CENTER);

        jPanel7.setLayout(new java.awt.GridLayout(0, 1));

        jLabel3.setText("Learning Rate (Alpha)");
        jPanel7.add(jLabel3);

        jLabel4.setText("Momentum");
        jPanel7.add(jLabel4);

        jPanel5.add(jPanel7, java.awt.BorderLayout.WEST);

        jPanel4.add(jPanel5, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel4, java.awt.BorderLayout.SOUTH);
        setJMenuBar(jMenuBar1);

        pack();
    }

    private void alphaComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        approxParameters.setAlpha(Double.parseDouble(alphaComboBox.getSelectedItem().toString()));
    }

    private void momentumComboBoxActionPerformed(java.awt.event.ActionEvent evt) {
        approxParameters.setMomentum(Double.parseDouble(momentumComboBox.getSelectedItem().toString()));
    }

    @Override
    public void dispose() {
        timer.stop();
        super.dispose();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        /* Set the Nimbus look and feel */
        
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http:
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | UnsupportedLookAndFeelException | IllegalAccessException | InstantiationException ex) {
            java.util.logging.Logger.getLogger(ApproximationDemo2D.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }





        /* Create and display the form */
        java.awt.EventQueue.invokeLater(() -> new ApproximationDemo2D().setVisible(true));
    }

    
    private javax.swing.JComboBox alphaComboBox;
    private jurls.examples.approximation.FunctionRenderer2D functionRenderer2D1;
    private jurls.examples.approximation.FunctionRenderer2D functionRenderer2D2;
    private javax.swing.JMenuBar jMenuBar1;

    private javax.swing.JComboBox momentumComboBox;

}
